 include "settings.inc"
  include "../ti83plus.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON
 EXTERN IsDeviceConnected,AutoSetup,GetClass,USBHostInit,DriverInit,KillUSBDevice,USBReqData,CheckUSBActive
 EXTERN GetIDs,MSD_Initialize,UFI_Initialize,FAT_Initialize,MSD_ImportVariable,MSD_ExportVariable,IPutS,IGetKey
 EXTERN KBDInit,KBDGetKey,GetErrorCode

LibHook:
       add    a,e
       ld     hl,6*7
       B_CALL EnoughMem
       jr     nc,$f
       B_JUMP ErrMemory
$$:
       B_CALL RclAns
       ld     a,(hl)
       cp     ListObj
       jr     z,$f
       B_JUMP ErrDataType
$$:
       push   de
       ld     hl,tempSwapArea
       ld     bc,7*9
       B_CALL MemClear             ;Clear RAM so ConvOP1 wont fail
       pop    de                   ;DE -> size bytes
       ld     a,(de)
       cp     8
       jr     c,$f
       ld     a,7
$$:
       ld     b,a
       add    a,a                  ;*2
       add    a,a                  ;*4
       add    a,a                  ;*8
       add    a,b                  ;*9
       ld     c,a
       ld     b,0
       inc    de
       inc    de
       ld     hl,tempSwapArea
       ex     de,hl
       push   de
       ldir                        ;Copy from list to tempSwapArea
       pop    hl                   ;HL -> list data
       call   ListToRegVals
       cp     NumBASICEntryPoints
       jr     c,$f
       ld     a,errEPIndex
       jr     BasicReturn
$$:
       push   hl
       push   de
       ld     l,a
       ld     h,0
       add    hl,hl
       ld     de,BASICEntryPointTable
       add    hl,de
       ld     e,(hl)
       inc    hl
       ld     d,(hl)
       push   de
       pop    ix
       pop    de
       pop    hl
       di     
       ld     iy,BasicReturn
       push   iy
       ld     iy,flags
       ei
       jp     (ix)
BASICEntryPointTable:
       dw     bIsDeviceConnected
       dw     bKillUSB
       dw     bMouseDemoInit
       dw     bMouseDemoDo
       dw     bGetClass
       dw     bGetIDs
       dw     bVersion
       dw     bMSDInit
       dw     bMSDImportVariable
       dw     bMSDExportVariable
       dw     bKBDInit
       dw     bKBDGetKey
       dw     bUSBInit
NumBASICEntryPoints EQU ($-BASICEntryPointTable)/2

bUSBInit:
       call USBHostInit
       jr c,$F
       xor a
       ret
$$:    call GetErrorCode
       ld a,b
       ld b,c
       ret

bMSDInit:
	ld hl,appBackUpScreen
	call DriverInit
	ld hl,appBackUpScreen+128
	ld de,appData
	call MSD_Initialize
	jr c,MSDErrorQuit
	call UFI_Initialize
	jr c,MSDErrorQuit
	call FAT_Initialize
	jr c,MSDErrorQuit
	xor a
	ret
MSDErrorQuit:
       ld a,(appBackUpScreen+offErrorCode)
	ret

bMSDImportVariable:
;B = string variable to use
;C = flags byte
	push bc
	ld hl,appBackUpScreen+384
	ld bc,256
	B_CALL MemClear
	B_CALL ZeroOP1
       ld hl,OP1
	ld (hl),04h
       inc hl
       ld (hl),0AAh
	pop bc
	push bc
	ld a,b
	dec a
	cp 0FFh
	jr nz,$F
	ld a,9
$$:    ld (OP1+2),a
	B_CALL ChkFindSym
	pop bc
       ld a,errMSDStrNotFound
	jr c,MSDErrorQuit
	push bc
	ld a,(de)
	ld b,a
	inc de
	inc de
	ex de,hl
	ld de,appBackUpScreen+384
bMSDIV_copyLoop:
	ld a,(hl)
       cp 0BBh
       jr nz,$F
       dec b
       jr z,bMSDIV_Done
       inc hl
       jr bMSDIV_Skip
$$:    cp 3Ah
	jr nz,$F
	ld a,'.'
$$:    cp 83h
	jr nz,$F
	ld a,'/'
$$:    ld (de),a
	inc de
bMSDIV_Skip:
	inc hl
	djnz bMSDIV_copyLoop
bMSDIV_Done:
	pop bc
	ld a,c
	ld hl,appBackUpScreen+384
	call MSD_ImportVariable
	jr c,MSDErrorQuit
	xor a
	ret

bMSDExportVariable:
;B = string variable to use
	push bc
	ld hl,appBackUpScreen+384
	ld bc,256
	B_CALL MemClear
	B_CALL ZeroOP1
       ld hl,OP1
       ld (hl),04h
       inc hl
       ld (hl),0AAh
	pop bc
	ld a,b
	dec a
	cp 0FFh
	jr nz,$F
	ld a,9
$$:ld (OP1+2),a
	B_CALL ChkFindSym
       ld a,errMSDStrNotFound
	jr c,MSDErrorQuit
;DE => size bytes of string
	push de
	B_CALL ZeroOP1
	pop de
	ld a,(de)
	ld b,a
	inc de
	inc de
	ld hl,OP1+1
	ld a,(de)
	cp 5Fh
	jr z,bMSDEV_isPrgm
bMSDEV_copyLoop:
	ld a,(de)
	cp 3Eh
	jr z,$F
	ld (hl),a
	inc hl
	inc de
	djnz bMSDEV_copyLoop
	jr $F
bMSDEV_isPrgm:
	ld a,ProgObj
	ld (OP1),a
	inc de
	djnz bMSDEV_copyLoop
$$:    inc de
	dec b
	ld hl,appBackUpScreen+384
	push hl
bMSDEV_copyLoop2:
	ld a,(de)
       cp 0BBh
       jr nz,$F
       dec b
       jr z,bMSDEV_Done
       inc de
       jr bMSDEV_Skip
$$:    cp 2Ah
	jr nz,$F
	ld a,'.'
$$:    cp 83h
	jr nz,$F
	ld a,'/'
$$:    ld (hl),a
	inc hl
bMSDEV_Skip:
	inc de
	djnz bMSDEV_copyLoop2
bMSDEV_Done:
	ld a,(OP1)
	cp ProgObj
	jr z,$F
	B_CALL FindSym
	jr nc,bMSDEV_export
	ld a,AppVarObj
	ld (OP1),a
$$:    B_CALL ChkFindSym
bMSDEV_export:
	pop hl
	xor a
	ld (OP1+9),a
	call MSD_ExportVariable
	jr c,MSDErrorQuit
	xor a
	ret

bVersion:
       xor    a
       ld     bc,UVersion
       ret

bKillUSB:
       rst    28h
       dw     5293h
       B_CALL ClrUSBHook              
       xor    a
       ret

bGetIDs:
       call   CheckUSBActive
       jr     nz,$f
       ld     hl,appBackUpScreen+1
       call   DriverInit
       call   USBHostInit
       jp     c,bMouseError
$$:
       ld     hl,appBackUpScreen+300
       call   GetIDs
       jr     c,bMouseError
       xor    a
       ret


bGetClass:
       call   CheckUSBActive
       jr     nz,$f
       ld     hl,appBackUpScreen+1
       call   DriverInit
       call   USBHostInit
       jp     c,bMouseError
$$:
       ld     hl,appBackUpScreen+300
       call   GetClass
       jr     c,bMouseError
       ld     d,c
       ld     c,b
       ld     b,a
       xor    a
       ret

bKBDInit:
       call   CheckUSBActive
       jr     nz,$f
       ld     hl,appBackUpScreen+1
       call   DriverInit
       call   USBHostInit
       jp     c,bMouseError
$$:
       ld     hl,appBackUpScreen+256
       ld     de,appBackUpScreen+300
       ld     b,0
       call   KBDInit
       jp     c,bMouseError
       xor    a
       ret

bKBDGetKey:
       call   KBDGetKey
       ld     h,a
       ld     a,errNoData
       ret    c
       xor    a
       ret

bMouseDemoInit:
       call   CheckUSBActive
       jr     nz,$f
       ld     hl,appBackUpScreen+1
       call   DriverInit
       call   USBHostInit
       jp     c,bMouseError
$$:
       ld     hl,appBackUpScreen+300
       call   GetClass
       jp     c,bMouseError
       cp     3
       jp     nz,bMouseClassError
       dec    b
       jp     nz,bMouseClassError
       dec    c
       dec    c
       jp     nz,bMouseClassError
       ld     hl,appBackUpScreen+300
       ld     de,bMouseEvent
       call   AutoSetup
       jp     c,bMouseError
       xor    a
       ret

bMouseClassError:
       ld     a,errBadClass
       jr     $f
bMouseError:
       ld     a,(appBackUpScreen+1+offErrorCode)
$$:
       push   af
       call   KillUSBDevice
       pop    af
       ret
bMouseDemoDo:
       xor    a
       ld     (appBackUpScreen),a
       ld     b,1
       call   USBReqData
       ld     b,15
$$:
       halt
       ld     a,(appBackUpScreen)
       or     a
       jr     nz,$f
       djnz   $b
       ld     a,errTimeout
       ret
$$:
       ld     a,(appBackUpScreen+1)
       ld     b,a
       ld     a,(appBackUpScreen+2)
       ld     c,a
       ld     a,(appBackUpScreen+3)
       ld     d,a
       ld     a,(appBackUpScreen+4)
       ld     e,a
       xor    a
       ret
       
bMouseEvent:
       ld     a,1
       ld     (appBackUpScreen),a
       ret



bIsDeviceConnected:
       call   IsDeviceConnected
       ld     b,0
       ld     a,b
       ret    z
       inc    b
       ret

BasicReturn:
       ;jp     RegValsToList ;*** falls through below ***

RegValsToList:
       push   hl
       push   de
       push   bc
       push   af
       B_CALL RclAns
       B_CALL DelVar
       B_CALL AnsName
;       ld     a,ListObj
;       ld     (OP1),a
       ld     hl,7
       B_CALL CreateRList
       inc    de
       inc    de
       pop    af                   ;A value
       call   ToListSaveDE
       pop    bc
       ld     a,b
       push   bc
       call   ToListSaveDE
       pop    bc
       ld     a,c
       call   ToListSaveDE
       pop    bc
       ld     a,b
       push   bc
       call   ToListSaveDE
       pop    bc
       ld     a,c
       call   ToListSaveDE
       pop    bc
       ld     a,b
       push   bc
       call   ToListSaveDE
       pop    bc
       ld     a,c
       jp     ToListSaveDE

ToListSaveDE:
       push   de
       ld     l,a
       ld     h,0
       B_CALL SetXXXXOP2
       ld     hl,OP2
       pop    de
       B_CALL Mov9B
       ret

ListToRegVals:
;HL -> List Data
       rst    20h
       call   ConvOP1SaveHL
       push   af            ;A on stack
       rst    20h
       call   ConvOP1SaveHL
       push   af            ;B on stack
       rst    20h
       call   ConvOP1SaveHL
       pop    bc
       ld     c,a
       push   bc            ;BC on stack
       rst    20h
       call   ConvOP1SaveHL
       push   af            ;D on stack
       rst    20h
       call   ConvOP1SaveHL
       pop    de
       ld     e,a
       push   de            ;DE on stack
       rst    20h
       call   ConvOP1SaveHL
       push   af            ;H on stack
       rst    20h
       B_CALL ConvOP1
       pop    hl
       ld     l,a
       pop    de
       pop    bc
       pop    af
       ret

ConvOP1SaveHL:
       push   hl
       B_CALL ConvOP1
       pop    hl
       ret
