
menuMain EQU 0
menuUSBInfo EQU 1
menuUSBInfoDes EQU 2
menuHIDDemos EQU 3
menuOtherDemos EQU 4
menuMassStorage EQU 5
menuHub EQU 6

errPort82			EQU 1
errPort91Bit2			EQU 2 ;Stall
errPort91Bit4			EQU 3 ;NAK
errPort4C			EQU 4
errPort4D	    	       EQU 5
errPort3A	           	EQU 6
errPort81                   EQU 7
errPort8C                   EQU 8
errPort8F                   EQU 9
errEPIndex                  EQU 10
errEPGetDes                 EQU 11
errNoDevice                 EQU 12
errFindDescriptor           EQU 13
errBadClass                 EQU 14
errTimeout                  EQU 15
errBadID                    EQU 16
errReadDescriptor           EQU 17
errInit                     EQU 18
errAutoSetup                EQU 19
errDemo                     EQU 20
errFindPipe                 EQU 21
errStub                     EQU 22
errGetMaxPacketSize		EQU 23
errSetAddress               EQU 24
errMSDSendCmd               EQU 25	;Problem sending bulk-only in/out commands
errMSDLargeSect             EQU 26	;Bytes-per-sector is larger than 512 (not supported)
errMSDNoParts               EQU 27	;No FAT12/16/32 primary partitions were found
errMSDNoMoreMemory          EQU 28	;Function failed because no more memory available (this is a bad thing, delete incomplete file/directories)
errMSDInvalidPartition      EQU 29	;Partition is invalid (does not contain 0AA55h)
errMSDNotFile               EQU 30	;Path is a directory or volume label, not file
errMSDNotValidPath          EQU 31	;Path is not in any way valid :)
errMSDCorruptFile           EQU 32	;File is corrupted or otherwise not as expected
errMSDNotFound              EQU 33	;File/directory was not found
errMSDDuplicateFound        EQU 34 ;Duplicate calculator variable was found and was not overwritten
errMSDNotEnoughMem          EQU 35 ;Not enough memory to create new calculator variable
errMSDAlreadyExists         EQU 36	;*.8x* of same name already exists
errMSDStrNotFound           EQU 37 ;String variable from BASIC OpenLib/ExecLib function not found
errMSDVarEmpty              EQU 38 ;Variable was empty and transfer was not completed (this is bad, delete incomplete file)
errMSDNoParts32		EQU 39 ;FAT32 partitions were found, but none were FAT16 (just a friendly message (now obsolete))
errNoData                   EQU 40
errVersion                  EQU 41
errBadCmd                   EQU 42
errFeatureDisabled          EQU 43
errMSDFailedCmd             EQU 44
errMSDCmdTimeout            EQU 45 ;Mass storage command timed out (no response from device at all)
errMSDCmdRefused            EQU 46 ;Mass storage command was refused (Stall on communication attempt)

usbPipe0      EQU 0000h
usbPipe1      EQU 0100h
usbPipe2      EQU 0200h
usbPipe3      EQU 0300h

pipeBulk       EQU 20h
pipeInt        EQU 30h

usbPacket8    EQU 0100h
usbPacket16   EQU 0200h
usbPacket32   EQU 0400h
usbPacket64   EQU 0800h

cbNewData EQU 0
cbStall   EQU 1
cbNak     EQU 2

descDevice    EQU 1
descConfig    EQU 2
descString    EQU 3
descInterface EQU 4
descEndpoint  EQU 5
descDQ        EQU 6
descOSC       EQU 7
descIP        EQU 8
descOnTheGo   EQU 9
descHID       EQU 21h
descReport    EQU 22h
descHub       EQU 29h


hubfeatLocalPower           EQU 0
hubfeatOverCurrent          EQU 1
hubfeatPortConnection       EQU 0
hubfeatPortEnable           EQU 1
hubfeatPortSuspend          EQU 2
hubfeatPortOverCurrent      EQU 3
hubfeatPortReset            EQU 4
hubfeatPortPower            EQU 8
hubfeatPowerLowSpeed        EQU 9
hubfeatPortConnectionChange EQU 10h              ;Someone doesn't know how to count
hubfeatPortEnableChange     EQU 11h
hubfeatPortSuspendChange    EQU 12h
hubfeatPortOverCurrentChange EQU 13h
hubfeatPortResetChange      EQU 14h
hubfeatPortTest             EQU 15h
hubfeatPortIndication       EQU 16h
       


pipeIn        EQU 1
pipeOut       EQU 2

pipeBitIn     EQU 0
pipeBitOut    EQU 1


;MemPtr EQU 9C16h
MemPtr EQU 0FFFEh
OutBuf EQU 9C29h


offInBuf             EQU 0                              ;64   do not reorder
offPacketSizeTable   EQU offInBuf+64                    ;8
offCallBackTable     EQU offPacketSizeTable+8           ;2
offErrorCode         EQU offCallBackTable+2             ;2
offHighAddr          EQU offErrorCode+2                 ;1
offLogPage           EQU offHighAddr+1                  ;1
offLogAddr           EQU offLogPage+1                   ;2
offLogDataAddr       EQU offLogAddr+2                   ;2
offFlags             EQU offLogDataAddr+2               ;1
offKBDBuf            EQU offFlags+1                     ;2
offPadBuf            EQU offKBDBuf+2                    ;2
offVernierBuf        EQU offPadBuf+2                    ;2
offStatus            EQU offVernierBuf+2                ;1
offMouseFlags        EQU offStatus+1                    ;1
offMouseBtn          EQU offMouseFlags+1                ;1
offMouseX            EQU offMouseBtn+1                  ;2
offMouseY            EQU offMouseX+2                    ;2
offMouseSavedData    EQU offMouseY+2                    ;1
offMouseCallBack     EQU offMouseSavedData+1            ;2
offMSDMemPtr         EQU offMouseCallBack+2             ;2
offMSDSectorBuffer   EQU offMSDMemPtr+2                 ;2
offMSDInterruptPipe  EQU offMSDSectorBuffer+2           ;1
offMSDCacheBuf       EQU offMSDInterruptPipe+1          ;2
offMSDCachePage      EQU offMSDCacheBuf+2               ;1


driverMemSize EQU offMSDCachePage+1



flagPort82    EQU 0
flagPump      EQU 1
flagMSDCBI    EQU 2 ;mass storage device is Control-Bulk-Interrupt
flagMSDInt    EQU 3 ;CBI mass storage device contains interrupt endpoint
flagCache     EQU 4 ;msd caching enabled
flagIsFAT32   EQU 5
flagIsFAT12   EQU 6

;File handle flags
flagEOF 		EQU 02h

padCheckBytes EQU 6

offpadLastData       EQU 0                              ;padCheckBytes
offpadFlags          EQU offpadLastData+padCheckBytes   ;1
offpadOffset         EQU offpadFlags+1                  ;1
offpadMask           EQU offpadOffset+1                 ;1
offpadCallBack       EQU offpadMask+1                   ;2
padMemSize           EQU offpadCallBack+2


offvernierCmdBuf     EQU 0                              ;8 do not reorder
offvernierMeas       EQU offvernierCmdBuf+8             ;2
offvernierCallBack   EQU offvernierMeas+2               ;2 do nor reorder
offvernierFlags      EQU offvernierCallBack+2           ;1 do not reorder

vernierMemSize       EQU offvernierFlags+1

vernierFlagCallBack  EQU 0

mouseMemSize EQU 7
msdMemSize EQU 5
msdBufferSize EQU 254
msdSectorSize EQU 512
fHandleLen	EQU 27

MSDBOTState                 EQU 0                        ;1 - bulk-only transport state (0 - nothing, 1 - getting data, 2 - CSW, 3+ - problems)
MSDLBA                      EQU MSDBOTState+1            ;4 - LBA address for read/write routines
MSDPartStart                EQU MSDLBA+4                 ;4 - start of FAT16 partition
MSDBPS                      EQU MSDPartStart+4           ;2 - bytes per sector (typically 512)
MSDDataInAddr               EQU MSDBPS+2                 ;2 - address of incoming/outgoing data
MSDDataInExpected           EQU MSDDataInAddr+2          ;2 - data expected to be received/sent
MSDSPC                      EQU MSDDataInExpected+2      ;1 - sectors per cluster (typically 2, 4, and so on)
MSDFATSectors               EQU MSDSPC+1                 ;2 - number of sectors per FAT
MSDRootDirSectors           EQU MSDFATSectors+2          ;2 - number of root directory sectors (something like 32)
MSDFirstDataSector          EQU MSDRootDirSectors+2      ;4 - first data sector
MSDFirstRootDirSecNum       EQU MSDFirstDataSector+4     ;2 - first sector of root
MSDFATStart                 EQU MSDFirstRootDirSecNum+2  ;2 - first sector of first FAT
MSDOutPipe                  EQU MSDFATStart+2            ;1 - bulk out pipe
MSDInPipe                   EQU MSDOutPipe+1             ;1 - bulk in pipe
MSDFAT_sector               EQU MSDInPipe+1              ;2 - temporary storage for FAT_getNextCluster output
MSDDescBuf                  EQU MSDFAT_sector+2          ;128 - buffer for descriptors
MSDBulkBuf                  EQU MSDDescBuf+128           ;31 - incoming data buffer
MSDPacketData               EQU MSDBulkBuf+31            ;64 - buffer to build data packets

;103+128 (231) bytes in tempSwapArea used for mass storage temporary space, along with OP6 in some routines
SPC_temp             EQU tempSwapArea          ;1
str_temp             EQU SPC_temp+1            ;14
time_temp            EQU str_temp+14           ;3
ixSave			EQU time_temp+3           ;2
temp_byte		EQU ixSave+2              ;1
store_ptr		EQU temp_byte+1           ;2
bytes_read		EQU store_ptr+2           ;2
remaining		EQU bytes_read+2          ;2
file_count		EQU remaining+2           ;2
root_indic		EQU file_count+2          ;1
sector_offset        EQU root_indic+1          ;1
sector_temp          EQU sector_offset+1       ;2
cluster_temp         EQU sector_temp+2         ;2
new_cluster          EQU cluster_temp+2        ;2
cur_cluster          EQU new_cluster+2         ;2
cluster_start        EQU cur_cluster+2         ;2
temp_handle          EQU cluster_start+2       ;27
packet_length        EQU temp_handle+27        ;2
temp_file            EQU packet_length+2       ;14
data_size            EQU temp_file+14          ;2
flag_byte            EQU data_size+2           ;1
address              EQU flag_byte+1           ;2
page                 EQU address+2             ;1
checksum             EQU page+1                ;2
OP1_temp             EQU checksum+2            ;11
temp_mem             EQU OP1_temp+11           ;128
cachetemp            EQU temp_mem+128          ;2


kbdMaxQ EQU 6
kbdRepeatMax EQU 2
kbdRepeat2 EQU 1

offkbdDataBuf        EQU 0                              ;6 - current keys being pressed
offkbdQ              EQU offkbdDataBuf+6                ;kbdMaxQ*2 - Key buffer queue
offkbdQSize          EQU offkbdQ+(kbdMaxQ*2)            ;1 - Number of keys in queue
offkbdFlags          EQU offkbdQSize+1                  ;1 - Keyboard driver flags
offkbdRepeatVal      EQU offkbdFlags+1                  ;1 - Key value to repeat
offkbdRepeatCount    EQU offkbdRepeatVal+1              ;1 - Repeat timer
offkbdCallBack       EQU offkbdRepeatCount+1            ;2 - callback passthrough
;DO NOT REORDER
kbdMemSize EQU offkbdCallBack+2

kbdFlagNoLocks EQU 0
kbdFlagNumLock EQU 1
kbdFlagCapsLock EQU 2
kbdFlagScrollLock EQU 3
kbdFlagCallBack EQU 4

kbdLCtrlBit EQU 0
kbdLShiftBit EQU 1
kbdLAltBit EQU 2
kbdLGUIBit EQU 3
kbdRCtrlBit EQU 4
kbdRShiftBit EQU 5
kbdRAltBit EQU 6
kbdRGUIBit EQU 7

kbdLCtrl EQU 1
kbdLShift EQU 2
kbdLAlt EQU 4
kbdLGUI EQU 8
kbdRCtrl EQU 16
kbdRShift EQU 32
kbdRAlt EQU 64
kbdRGUI EQU 128

kbdK1         EQU 1Eh
kbdK2         EQU 1Fh
kbdK3         EQU 20h
kbdK4         EQU 21h
kbdK5         EQU 22h
kbdK6         EQU 23h
kbdK7         EQU 24h
kbdK8         EQU 25h
kbdK9         EQU 26h
kbdK0         EQU 27h

kbdKBackQuote EQU 35h       ;` ~
kbdKMinus     EQU 2Dh       ;- _
kbdKEqu       EQU 2Eh       ;= +
kbdKBackSpace EQU 2Ah
kbdKEsc       EQU 29h
kbdKTab       EQU 2Bh
kbdKCapsLock  EQU 39h
kbdKLBrack    EQU 2Fh
kbdKRBrack    EQU 30h
kbdKBackSlash EQU 31h
kbdKSemicolon EQU 33h
kbdKApostrophe EQU 34h
kbdKEnter     EQU 28h
kbdKComma     EQU 36h
kbdKPeriod    EQU 37h
kbdKSlash     EQU 38h
kbdKSpace     EQU 2Ch

kbdKA         EQU 4
kbdKB         EQU 5
kbdKC         EQU 6
kbdKD         EQU 7
kbdKE         EQU 8
kbdKF         EQU 9
kbdKG         EQU 0Ah
kbdKH         EQU 0Bh
kbdKI         EQU 0Ch
kbdKJ         EQU 0Dh
kbdKK         EQU 0Eh
kbdKL         EQU 0Fh
kbdKM         EQU 10h
kbdKN         EQU 11h
kbdKO         EQU 12h
kbdKP         EQU 13h
kbdKQ         EQU 14h
kbdKR         EQU 15h
kbdKS         EQU 16h
kbdKT         EQU 17h
kbdKU         EQU 18h
kbdKV         EQU 19h
kbdKW         EQU 1Ah
kbdKX         EQU 1Bh
kbdKY         EQU 1Ch
kbdKZ         EQU 1Dh

kbdKF1        EQU 3Ah
kbdKF2        EQU 3Bh
kbdKF3        EQU 3Ch
kbdKF4        EQU 3Dh
kbdKF5        EQU 3Eh
kbdKF6        EQU 3Fh
kbdKF7        EQU 40h
kbdKF8        EQU 41h
kbdKF9        EQU 42h
kbdKF10       EQU 43h
kbdKF11       EQU 44h
kbdKF12       EQU 45h

kbdKRight     EQU 4Fh
kbdKLeft      EQU 50h
kbdKDown      EQU 51h
kbdKUp        EQU 52h

kbdKSysRq     EQU 46h
kbdKScrollLock EQU 47h
kbdKBreak     EQU 48h
kbdKInsert    EQU 49h
kbdKHome      EQU 4Ah
kbdKPageUp    EQU 4Bh
kbdKDelete    EQU 4Ch
kbdKEnd       EQU 4Dh
kbdKPageDown  EQU 4Eh

kbdKNumLock   EQU 53h
kbdKNSlash    EQU 54h
kbdKNStar     EQU 55h
kbdKNMinus    EQU 56h
kbdKNPlus     EQU 57h
kbdKNEnter    EQU 58h
kbdKN1        EQU 59h
kbdKN2        EQU 5Ah
kbdKN3        EQU 5Bh
kbdKN4        EQU 5Ch
kbdKN5        EQU 5Dh
kbdKN6        EQU 5Eh
kbdKN7        EQU 5Fh
kbdKN8        EQU 60h
kbdKN9        EQU 61h
kbdKN0        EQU 62h
kbdKNPeriod   EQU 63h      



mouseRight    EQU 1
mouseLeft     EQU 2
mouseUp       EQU 4
mouseDown     EQU 8

mouseBitRight EQU 0
mouseBitLeft  EQU 1
mouseBitUp    EQU 2
mouseBitDown  EQU 3

mouseThreshold EQU 15               ;How many mouse ticks = one keypress

mfDiag        EQU 0
mfSavedData   EQU 6
mfSwitch      EQU 7



DISAVE MACRO
 IF INTERRUPTMACRO_TYPE=0
       ld     (83EBh),a
       ld     a,i
       push   af
       di
       ld     a,(83EBh)
 ELSEIF INTERRUPTMACRO_TYPE=1
       di
 ENDIF
 ENDMAC

EIRESTORE MACRO
 IF INTERRUPTMACRO_TYPE=0
       push   af
       push   hl
       ld     hl,4
       add    hl,sp
       bit    2,(hl)
       jr     z,$eir
       ei
$eir:
       pop    hl
       pop    af
       inc    sp
       inc    sp
 ELSEIF INTERRUPTMACRO_TYPE=1
       ei
 ENDIF
 ENDMAC 
 
 
;EIRESTORE MACRO
;       ex     af,af'
;       pop    af
;       jp     po,$f
;       ex     af,af'
;       ei
;       jr     $+3
;$$:
;       ex     af,af'
; ENDMAC       



ASSERTC MACRO first,second
 ifeq "_&first","_b"
  ERROR "First assertion value cannot be register B"
 endif
 ifeq "_&first","_a"
  ERROR "First assertion value cannot be register A"
 endif
 IF ASSERT_ON=1
       push   bc
       push   af
       ld     a,second
       ld     b,a
       ld     a,first
       cp     b
       call   nc,DoAssert
       pop    af
       pop    bc
 ENDIF
 ENDMAC

ASSERTZ MACRO first,second
 ifeq "_&first","_b"
  ERROR "First assertion value cannot be register B"
 endif
 ifeq "_&first","_a"
  ERROR "First assertion value cannot be register A"
 endif
 IF ASSERT_ON=1
       push   bc
       push   af
       ld     a,second
       ld     b,a
       ld     a,first
       cp     b
       call   nz,DoAssert
       pop    af
       pop    bc
 ENDIF
 ENDMAC

ASSERTNC MACRO first,second
 ifeq "_&first","_b"
  ERROR "First assertion value cannot be register B"
 endif
 ifeq "_&first","_a"
  ERROR "First assertion value cannot be register A"
 endif
 IF ASSERT_ON=1
       push   bc
       push   af
       ld     a,second
       ld     b,a
       ld     a,first
       cp     b
       call   c,DoAssert
       pop    af
       pop    bc
 ENDIF
 ENDMAC

ASSERTNZ MACRO first,second
 ifeq "_&first","_b"
  ERROR "First assertion value cannot be register B"
 endif
 ifeq "_&first","_a"
  ERROR "First assertion value cannot be register A"
 endif
 IF ASSERT_ON=1
       push   bc
       push   af
       ld     a,second
       ld     b,a
       ld     a,first
       cp     b
       call   z,DoAssert
       pop    af
       pop    bc
 ENDIF
 ENDMAC



LOG MACRO first, second
 IF LOGGING_ON=1
 IFNDEF DoLog
  EXTERN DoLog
 ENDIF

 IF "log&first"="logGetMaxPacketSize" && LOGGETMAXPACKETSIZE_ON != 1
 ELSEIF "log&first"="logData" && LOGDATA_ON !=  1
 ELSEIF "log&first"="logGetClass" && LOGGETCLASS_ON != 1   
 ELSEIF "log&first"="logGetIDs" && LOGGETIDS_ON != 1
 ELSEIF "log&first"="logReadDescriptor" && LOGREADDESCRIPTOR_ON != 1
 ELSEIF "log&first"="logQuit" && LOGQUIT_ON != 1
 ELSEIF "log&first"="logSendData" && LOGSENDDATA_ON != 1
 ELSEIF "log&first"="logSendControlData" && LOGSENDCONTROLDATA_ON != 1
 ELSEIF "log&first"="logAutoSetup" && LOGAUTOSETUP_ON != 1
 ELSEIF "log&first"="logDataEnd" && LOGDATA_ON != 1
 ELSEIF "log&first"="logInA0Start" && LOGINA0START_ON != 1
 ELSEIF "log&first"="logOutA0Start" && LOGOUTA0START_ON != 1
 ELSEIF "log&first"="logHostInit" && LOGHOSTINIT_ON != 1
 ELSEIF "log&first"="logKillDevice" && LOGKILLDEVICE_ON != 1
 ELSEIF "log&first"="logKillDriver" && LOGKILLDRIVER_ON != 1
 ELSEIF "log&first"="logSetupLog" && LOGSETUPLOG_ON != 1
 ELSEIF "log&first"="logInData" && LOGINDATA_ON != 1
 ELSEIF "log&first"="logCallBack" && LOGCALLBACK_ON != 1
 ELSEIF "log&first"="logError" && LOGERROR_ON != 1
 ELSEIF "log&first"="logSetAddress" && LOGSETADDRESS_ON != 1
 ELSEIF "log&first"="logLogDone" && LOGLOGDONE_ON != 1
 ELSEIF "log&first"="logDataStart" && LOGDATA_ON != 1
 ELSEIF "log&first"="logCustom" && LOGCUSTOM_ON != 1
 ELSEIF "log&first"="logInterrupt" && LOGINTERRUPT_ON !=1
 ELSEIF "log&first"="logKBDInit" && LOGKBDINIT_ON !=1
 ELSEIF "log&first"="logKBDGetKey" && LOGKBDGETKEY_ON !=1
 ELSEIF "log&first"="logMSDInit" && LOGMSDINIT_ON !=1
 ELSEIF "log&first"="logUFIInit" && LOGUFIINIT_ON !=1
 ELSEIF "log&first"="logFATInit" && LOGFATINIT_ON !=1
 ELSEIF "log&first"="logPadInit" && LOGPADINIT_ON !=1
 ELSEIF "log&first"="logPadStart" && LOGPADSTART_ON !=1
 ELSEIF "log&first"="logPadSetup" && LOGPADSETUP_ON !=1
 ELSEIF "log&first"="logPadCallBack" && LOGPADCALLBACK_ON !=1
 ELSEIF "log&first"="logCache" && LOGCACHE_ON !=1
 ELSE
       push   bc
       ifneq "_&second", "_"
              ld     c,second
       else
              ld     c,0
       endif
       ld     b,log&first
       call   DoLog
       pop    bc
 ENDIF
 ENDIF
 ENDMAC

logGetMaxPacketSize EQU 1
logData EQU 2
logGetClass EQU 3
logGetIDs EQU 4
logReadDescriptor EQU 5
logQuit EQU 6
logSendData EQU 7
logSendControlData EQU 8
logAutoSetup EQU 9
logDataEnd EQU 10
logInA0Start EQU 11
logOutA0Start EQU 12
logHostInit EQU 13
logKillDevice EQU 14
logKillDriver EQU 15
logSetupLog EQU 16
logInData EQU 17
logCallBack EQU 18
logError EQU 19
logSetPortFeature EQU 20
logClearPortFeature EQU 21
logGetDeviceStatus EQU 22
logSetHubFeature EQU 23
logClearHubFeature EQU 24
logGetHubStatus EQU 25
logGetHubPortStatus EQU 26
logSetAddress EQU 27
logLogDone EQU 28
logDataStart EQU 29
logCustom EQU 30
logInterrupt EQU 31
logKBDInit EQU 32
logKBDGetKey EQU 33
logMSDInit EQU 34
logUFIInit EQU 35
logFATInit EQU 36
logPadInit EQU 37
logPadStart EQU 38
logPadSetup EQU 39
logPadCallBack EQU 40
logPumpOn EQU 41
logPumpOff EQU 42
logPump EQU 43
logCache EQU 44


logCacheOn           EQU 0
logCacheOff          EQU 1
logCacheIsInCache    EQU 2
logCacheReadFromCache EQU 3
logCacheResetLRU     EQU 4
logCacheSaveToCache  EQU 5




vernierCMD_ID_GET_STATUS EQU 10h
vernierCMD_ID_WRITE_LOCAL_NV_MEM_1BYTE EQU 11h
vernierCMD_ID_WRITE_LOCAL_NV_MEM_2BYTES EQU 12h
vernierCMD_ID_WRITE_LOCAL_NV_MEM_3BYTES EQU 13h
vernierCMD_ID_WRITE_LOCAL_NV_MEM_4BYTES EQU 14h
vernierCMD_ID_WRITE_LOCAL_NV_MEM_5BYTES EQU 15h
vernierCMD_ID_WRITE_LOCAL_NV_MEM_6BYTES EQU 16h
vernierCMD_ID_READ_LOCAL_NV_MEM EQU 17h
vernierCMD_ID_START_MEASUREMENTS EQU 18h
vernierCMD_ID_STOP_MEASUREMENTS EQU 19h
vernierCMD_ID_INIT EQU 1Ah
vernierCMD_ID_SET_MEASUREMENT_PERIOD EQU 1Bh
vernierCMD_ID_GET_MEASUREMENT_PERIOD EQU 1Ch
vernierCMD_ID_SET_LED_STATE EQU 1Dh
vernierCMD_ID_GET_LED_STATE EQU 1Eh
vernierCMD_ID_GET_SERIAL_NUMBER EQU 20h

vernierLED_COLOR_BLACK EQU 0C0h
vernierLED_COLOR_RED EQU 40h
vernierLED_COLOR_GREEN EQU 80h
vernierLED_COLOR_RED_GREEN EQU 0
vernierLED_BRIGHTNESS_MIN EQU 0
vernierLED_BRIGHTNESS_MAX EQU 10h

vernierMASK_INPUT_PACKET_TYPE EQU 0C0h
vernierINPUT_PACKET_TYPE_MEAS EQU 00h
vernierINPUT_PACKET_CMD_RESP  EQU 40h
vernierINPUT_PACKET_INIT_RESP EQU 80h
vernierINPUT_PACKET_NOTIFICATION EQU 0C0h
vernierMASK_INPUT_PACKET_ERROR_FLAG EQU 20h


DEBUG MACRO first
       push   af
       ld     a,first
       call   DispHexA
       pop    af
 ENDMAC

PutText MACRO first,second,third
 segment TextSpace
$$:
 ifneq "_&second" , "_"
       db     &third,0
  else
       db     &first,0
  endif     
 segment Main
  ifneq "_&second" ,"_"
       ld     de,&first*256+&second
       ld     (curRow),de
  endif
       ld     hl,$B
       call   PutSApp
 ENDMAC


Var MACRO first, second
 segment MemVars
&first:
       ds     second
 segment Main
 ENDMAC


